$:.unshift File.dirname( __FILE__ )
require "text_analysis"

raw_data = File.read("romeo_and_juliet.txt")
text = /.*1595(.*)THE END.*/m.match(raw_data)[1]

# Alternativ:
# text = ""
# in_license_block = true
# File.open("romeo_and_juliet.txt", "r+").each do |line|
#   in_license_block = false if line =~ /1595/
#   in_license_block = true if line =~ /THE END/
# 
#   text << line unless in_license_block
# end

number_of_rare_words = 5
number_of_rare_words = ARGV[0].to_i if ARGV[0]

rarest_words = rare_words(text, number_of_rare_words)
puts "The #{number_of_rare_words} rarest words are:"
puts "---------------------------------------------"
rarest_words.each do |word, count|
  puts "  #{word} (#{count})"
end

puts
puts "The lines containing the rarest words are:"
puts "------------------------------------------"
pattern = rarest_words.keys.join("|")
text.each_line do |line|
  puts " " + line if line =~ /#{pattern}/i
end

puts
puts "Number of speeches"
puts "------------------"

characters =  text.scan(/^\s{2}[A-Z][a-z]+\./).map(&:strip)

speech_count = Hash.new(0)

characters.each do |char|
  speech_count[char] += 1
end

speech_count.sort_by { |char, count| count }.each do |char, count|
  puts "#{char} (#{count})"
end
